-module(jsfw_pid).
-export([get/0, get/1, input/1]).

get() ->
    PIDs = erlang:processes(),
    Key = fun(K,PID) -> proplists:get_value(K, erlang:process_info(PID)) end,

    [[
        PID,
        % Return initial call if process not registered
        case Key(registered_name,PID) == undefined of
            true ->
                Key(initial_call,PID);
            false ->
                Key(registered_name,PID)
        end,
        Key(current_function,PID)

     ] || PID <- PIDs ].

get(Arg) ->
    PID = jsfw_utility:arg_to_pid(Arg),
    Info = erlang:process_info(PID),
    io:format("Info: ~p~n", [Info]),
    [ [Key, Value] || {Key, Value} <- Info ].

input(Input) ->
    io:format("JSFW_PID.erl received input: ~p~n", [Input]).