var jsfw_settings = new function() {
	this.init = function() {
		console.log("jsfw_settings.init()");

		$.getJSON("/json/components", function(json) {
			$("#content").empty();
			$("#content").append("<h1>Configure components</h1>");
			var table = "<table><thead><tr><th>Component ID</th><th>Display name</th><th>Enabled?</th><th></th></tr></thead>";
			$.each(json, function(component, row) {
				// Variable to hold component status
				var enabled = (row.enabled == "true" ? true : false);
				table += (enabled ? "<tr>" : "<tr class='disabled'>");
				table += "<td>" + component + "</td>";

				// These are added "manually" as we want to preserve the order when updating these
				table += "<td>" + row.displayname + "</td>";
				table += "<td>" + row.enabled + "</td>";

				// Include a link to enable/disable the component
				table += "<td>";
				var href = (enabled ? "manage/disablecomponent/" : "manage/enablecomponent/");
				table += "<a class='togglestatus' href='" + href + component + "'>";
				table += (enabled ? "disable" : "enable");
				table += "</a></td>";
				table += "</tr>";
			});
			table += "</table>";
			$("#content").append(table);

			// Handle clicks, reloads components
			$("a.reload").click(function() {
				console.log("reload clicked!");
				$.post($(this).attr("href"), function(data) {
					console.log("return from post: " + data);
				});
				return false;
			});

			// Handle clicks, toggling of component status
			$("a.togglestatus").click(function() {
				// ["manage", "enablecomponent"/"disablecomponent", COMPONENT]
				var component = $(this).attr('href').split("/")[2];
				$.post($(this).attr('href'), function(data) {
					console.log("Result from toggle status post: " + data);
				});

				if ($(this).html() == "enable") {
					jsfw_settings.init();
					// Display the link in the menu
					$.each($("#menu ul#components li").has("a"), function(i, li) {
						// Show the li that contains the <a> tag with href=component
						var href = $(this).find("a").attr('href').replace("/","");
						if (href == component) {
							$(this).show(1000);
						}
					});
				}
				else {
					jsfw_settings.init();
					// Hide the link from the menu
					$.each($("#menu ul#components li").has("a"), function(i, li) {
						// Hide the li that contains the <a> tag with href=component
						var href = $(this).find("a").attr('href').replace("/","");
						if (href == component) {
							$(this).hide(1000);
						}
					});
				}
				return false;
			});

			// Add a section for adding new components through the web interface
			$("#content").append("<h1>Add components</h1>");
			$("#content").append("<form id='addcomponent'>");
			$("#addcomponent").append("<label for='componentid'>Component ID</label><input type='text' name='componentid' id='componentid' />");
			$("#addcomponent").append("<span class='required'>*</span>");
			$("#addcomponent").append("<label for='displayname'>Display name</label><input type='text' name='displayname' id='displayname' />");
			$("#addcomponent").append("<span class='inputdescription'>Optional. If left out it will be the component id.</span>");
			$("#addcomponent").append("<input type='submit' value='Save' />");
			$("#content").append("<span id='result'></span>");
			$("form#addcomponent").submit(function() {

				var id = $(this).find("#componentid").val();
				var name = ($(this).find("#displayname").val() == "" ? id : $(this).find("#displayname").val());
				// Short validation, if no id given, alert the user
				if (id == "") {
					$("span.required").html("* required!");
				}
				else {
					var res = $.post("/manage/createcomponent/" + id + "?displayname=" + name + "&enabled=true", function(data) {
						$("span#result").html(data).attr("class","info");
						// TODO: update the list of components when we add a new one
						// TODO: update the components menu when we add a new one
					}).error(function() { // If an error is returned from the post request, display it
						$("span#result").html("Couldn't create component. Component ID taken.").attr("class","error");
					});
				}
				return false;
			})
		});

	}
}