-module(users).
-export([init/0, input/1, get/0, get/1]).

% INTERNAL
-export([user_loop/1]).

-record(user, {
	id,
	name,
	job,
	age
}).

init() ->
    io:format("Init called!~n"),
    case whereis(userserver) of
        undefined ->
            register(userserver, spawn(?MODULE, user_loop, [[]]));
        _ ->
            already_registered
    end.


user_loop(Users) ->
    receive
        {From, listusers} ->
            From ! Users,
            user_loop(Users);
        {_From, add, User} when is_atom(User) ->
            BinUser = list_to_binary(atom_to_list(User)),
            NewUsers = [BinUser|Users],
            user_loop(NewUsers);
        {_From, add, User} when is_list(User) ->
            BinUser = list_to_binary(User),
            NewUsers = [BinUser|Users],
            user_loop(NewUsers)
    end.

%% Table data is on the format
%% [[row1col1, row1col2, ...], [row2col1, row2col2, ...], ... ]
get() ->
    userserver ! {self(), listusers},
    receive
        Users ->
            Table = [[U] || U <- Users],
	        Table
	end.

%% Here we are given a user id as argument
get(Arg) ->
	io:format("Arg: ~p~n", [Arg]),
	Arg.

input(Input) ->
    io:format("Received input:~p~n", [Input]),
    userserver ! {self(), add, Input}.


